package com.example.nav_color_bottom;

import android.graphics.Color;
import android.os.Build;
import android.util.Log;
import android.view.Window;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** NavColorBottomPlugin */
public class NavColorBottomPlugin implements MethodCallHandler {
  /** Plugin registration. */

  private static String TAG = "NavColorBottomPlugin";
  private final Registrar registrar;

  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "nav_color_bottom");
    final NavColorBottomPlugin instance = new NavColorBottomPlugin(registrar);
    channel.setMethodCallHandler(instance);
  }

  NavColorBottomPlugin(Registrar registrar) {
    this.registrar = registrar;
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("changeColor")) {
      Log.d( TAG, "changeColor >>>>>>>>>");

      final String value = call.argument("value");

      Log.d(TAG, "value: "+ value);

      this.registrar.activity().runOnUiThread(new Runnable() {
        @Override
        public void run() {
          setNavigationBarBackgroundColor(value, true);
        }
      });

      result.success( "true" );
    } else {
      result.notImplemented();
    }
  }

  private void setNavigationBarBackgroundColor(final String colorPref, Boolean ligthNavigationBar) {
    ligthNavigationBar = ligthNavigationBar == null ? false : ligthNavigationBar;
    if (Build.VERSION.SDK_INT >= 21) {
      if (colorPref != null && !colorPref.isEmpty()) {
        final Window window = this.registrar.activity().getWindow();
        int uiOptions = window.getDecorView().getSystemUiVisibility();
        uiOptions = uiOptions | 0x80000000;
        if(Build.VERSION.SDK_INT >= 26 && ligthNavigationBar)
          uiOptions = uiOptions | 0x00000010;
        else
          uiOptions = uiOptions & ~0x00000010;
        window.getDecorView().setSystemUiVisibility(uiOptions);
        try {
            window.getClass().getDeclaredMethod("setNavigationBarColor", int.class).invoke(window, Color.parseColor(colorPref));
        } catch (IllegalArgumentException ignore) {
            Log.e(TAG, "Invalid hexString argument, use f.i. '#999999'");
        } catch (Exception ignore) {
            Log.w(TAG, "Method window.setNavigationBarColor not found for SDK level " + Build.VERSION.SDK_INT);
        }
      }
    }
  }
}
